#ifndef SHP_FILE_H
#define SHP_FILE_H

#include "shp_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <list>

class SHP_File
{
public:
	SHP_File() : fp(0) {}
	~SHP_File() { for (std::list<SHP_MIX*>::iterator it = ShapeList.begin(); it != ShapeList.end(); it++) DestroySHPMIX( *it ); }

	void     OpenSHPFile(char* filename);
	void     CloseSHPFile() { if (fp) fclose(fp); } 
	void     ReadSHPFile();

	SHP_FILE_HEADER GetSHPFileHeader(){ return shp_fh; }

	void     CollapsePoints(   int& points, double*& xarray, double*& yarray);
	void     CollapsePolygons( int& points, int& parts, int*& starts, int*& partlengths, double*& xarray, double*& yarray);
	void     CollapsePolylines(int& points, int& parts, int*& starts, int*& partlengths, double*& xarray, double*& yarray);

public:
	std::list<SHP_MIX*> ShapeList;
	double              Box[4];

private:
	SHP_MIX* ReadSHPRecord();

	void CollapsePolyX(int& points, int& parts, int*& starts, int*& partlengths, double*& xarray, double*& yarray, int type);
	void Convert_SHP_FILE_HEADER(SHP_FILE_HEADER& shp_fh);
	void Convert_SHP_RECORD_HEADER(SHP_RECORD_HEADER& shp_rh);
	void DestroySHPMIX(SHP_MIX* s);

	FILE* fp;
	SHP_FILE_HEADER   shp_fh;
	SHP_RECORD_HEADER shp_rh;
};


#endif
